#import <Cocoa/Cocoa.h>
#import <OpenGL/OpenGL.h>
#import <OpenGL/gl.h>
#import <OpenGL/glu.h>
#import <GLUT/glut.h>
#import "Cell.h"

#define DEFAULT_ANIMATION_INTERVAL 0.01
#define BITS_PER_PIXEL 32.0
#define DEPTH_SIZE 32.0
#define BOXWIDTH 100.0

#define SCALE 50.0

@interface HJ3dCage : NSOpenGLView {
	
	// OpenGL-specific variables:
	
	NSOpenGLPixelFormatAttribute pfAttribs[32];
	NSOpenGLPixelFormat *nsglFormat;
	NSOpenGLContext *glContext;
	GLfloat cameraAngle;
	
	// User interface variables:
	
	float boxWidth, magnification, rotationSpeed, colorRotationAngle, yHeight, xzAngle;
	BOOL boxVisible, animate, stateChanged, subcells;
	NSPoint currentPosition, startPosition;
	int shape;
	
	// Animation variables:
	
	NSTimer *animationTimer;
	NSTimeInterval animationInterval;
	
	// Contained object variables:
	
	NSMutableArray *objects;
}

// OpenGL methods

-(void)positionCamera;
-(void)drawOutlineBox;
-(void)initGL;
-(void)light1;

// Contained object methods

-(void)addCell:(Cell *)newCell;
-(void)setMagnification:(float)newMagnification;
-(void)setRotationSpeed:(float)newRotationSpeed;
-(void)setShape:(int)newShape;
-(void)setSubcells:(BOOL)newSubcells;
-(void)setAnimation:(BOOL)animationState;
-(void)clearObjects;

@end
